import functools
from ..models.error_model import  Error


def check_error(function):
    @functools.wraps(function)
    def wrapper(*args, **kwargs):
        try:
            return function(*args, **kwargs)
        except Error as err:
            return err.to_problem()
        except ValueError as err:
            return Error(status=400, title='Error Value', type='RG-000', key=err.__str__()).to_problem() 
        else:
            return Error(status=500, title='Error System', type='UNKNOW', key=err.__str__()).to_problem() 
    return wrapper