# coding: utf-8

from __future__ import absolute_import

from flask import json
from six import BytesIO

from swagger_server.models.error_model import ErrorModel  # noqa: E501
from swagger_server.models.people import People  # noqa: E501
from swagger_server.models.people_crud import PeopleCRUD  # noqa: E501
from swagger_server.test import BaseTestCase
from swagger_server.models.peoples import Peoples

from swagger_server.models.department_crud import DepartmentCRUD  # noqa: E501
from swagger_server.models.department import Department  # noqa: E501
from swagger_server.models.departments import Departments  # noqa: E501

class TestPeopleController(BaseTestCase):
    """PeopleController integration test stubs"""

    
    def setUp(self):
        BaseTestCase.setUp(self)

    def test_add_people(self):
        """Test case for add_people

        Add a new people
        """
        body = PeopleCRUD()
        body.firstname = "firstname"
        body.lastname = "lastname"
        body.gender = "M"
        body.department = self.create_department().id
        response = self.client.open(
            '/api/v1/people',
            method='POST',
            data=json.dumps(body),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def create_department(self):
        try:
            dept = Departments().getDepartmentById(999)
        except:
            dept = Department(id=999,lib="test dept")
            Departments().append(dept)
        return dept 

    def create_people(self):
        try:
            people = Peoples().getPeopleById(998)
        except:
            people = People(id=998, firstname="firstname", lastname="lastname", gender="M", department=self.create_department())
            Peoples().append(people)
        return people

    def test_delete_people(self):
        """Test case for delete_people

        Deletes a people
        """

        response = self.client.open(
            '/api/v1/people/{peopleId}'.format(peopleId=self.create_people().id),
            method='DELETE',
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_people(self):
        """Test case for get_people

        Find people by ID
        """
        people = self.create_people()
        response = self.client.open(
            '/api/v1/people/{peopleId}'.format(peopleId=people.id),
            method='GET',
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_get_peoples(self):
        """Test case for get_peoples

        list of people
        """
        query_string = [('gender', 'gender_example'),
                        ('department', 56)]
        self.create_people()
        response = self.client.open(
            '/api/v1/people',
            method='GET',
            content_type='application/json',
            query_string=query_string)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_update_people(self):
        """Test case for update_people

        Updates a people with form data
        """
        response = self.client.open(
            '/api/v1/people/{peopleId}'.format(peopleId=self.create_people().id),
            method='PUT',
            data=json.dumps({
                "age": 6,
                "department": 999,
                "email": "email@email.fr",
                "firstname": "firstname",
                "gender": "M",
                "lastname": "lastname"
                }),
            content_type='application/json')
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    import unittest
    unittest.main()
